/[gentoo-x86]/eclass/gtk-sharp-module.eclass
Gentoo

Diff of /eclass/gtk-sharp-module.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.6 Revision 1.19
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2008 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/gtk-sharp-module.eclass,v 1.6 2008/11/28 00:20:08 loki_val Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/gtk-sharp-module.eclass,v 1.19 2009/03/09 01:02:13 loki_val Exp $
4 4
5# Author : Peter Johanson <latexer@gentoo.org>, butchered by ikelos, then loki_val. 5# @ECLASS: gtk-sharp-module.eclass
6# Based off of original work in gst-plugins.eclass by <foser@gentoo.org> 6# @MAINTAINER:
7# dotnet@gentoo.org
8# @BLURB: Manages the modules of the gtk-, gnome-, and gnome-desktop-sharp tarballs
9# @DESCRIPTION:
10# This eclass provides phase functions and helper functions for the modules
11# of the gtk-sharp, gnome-sharp and gnome-desktop-sharp tarballs.
12# PLEASE TAKE NOTE: ONLY FOR EAPI-2 EBUILDS
7 13
8# Note that this breaks compatibility with the original gtk-sharp-component 14WANT_AUTOMAKE=none
9# eclass. 15WANT_AUTOCONF=none
10 16
11inherit eutils mono multilib autotools 17inherit eutils mono multilib autotools base versionator
12 18
13# Get the name of the component to build and the build dir; by default, 19# @ECLASS-VARIABLE: GTK_SHARP_MODULE
14# extract it from the ebuild's name. 20# @DESCRIPTION:
21# The name of the Gtk# module.
22# Default value: ${PN/-sharp/}
15GTK_SHARP_MODULE=${GTK_SHARP_MODULE:=${PN/-sharp/}} 23GTK_SHARP_MODULE=${GTK_SHARP_MODULE:=${PN/-sharp/}}
24
25# @ECLASS-VARIABLE: GTK_SHARP_MODULE_DIR
26# @DESCRIPTION:
27# The subdirectory of S in which GTK_SHARP_MODULE is installed.
28# Default value: ${PN/-sharp/}
16GTK_SHARP_MODULE_DIR=${GTK_SHARP_MODULE_DIR:=${PN/-sharp/}} 29GTK_SHARP_MODULE_DIR=${GTK_SHARP_MODULE_DIR:=${PN/-sharp/}}
17 30
18# In some cases the desired module cannot be configured to be built on its own. 31# @ECLASS-VARIABLE: GTK_SHARP_REQUIRED_VERSION
19# This variable allows for the setting of additional configure-deps. 32# @DESCRIPTION:
20GTK_SHARP_MODULE_DEPS="${GTK_SHARP_MODULE_DEPS}" 33# The version of the gtk-sharp tarball this package requires.
21 34# Optional.
22# Allow ebuilds to set a value for the required GtkSharp version; default to
23# ${PV}.
24GTK_SHARP_REQUIRED_VERSION=${GTK_SHARP_REQUIRED_VERSION:=${PV%.*}} 35GTK_SHARP_REQUIRED_VERSION="${GTK_SHARP_REQUIRED_VERSION}"
25 36
26# Version number used to differentiate between unversioned 1.0 series and the 37# @ECLASS-VARIABLE: gapi_users_list
27# versioned 2.0 series (2.0 series has 2 or 2.0 appended to various paths and 38# @DESCRIPTION:
28# scripts). Default to ${SLOT}. 39# List of modules that use one of gapi2-codegen, gapi2-fixup or gapi2-parser
29GTK_SHARP_SLOT="${GTK_SHARP_SLOT:=${SLOT}}" 40# No ebuild-serviceable parts inside.
30GTK_SHARP_SLOT_DEC="${GTK_SHARP_SLOT_DEC:=-${GTK_SHARP_SLOT}.0}" 41gapi_users_list="art gnome gnomevfs ${gnome_desktop_sharp_module_list} atk gtk gdk glade pango"
31 42
32# Set some defaults. 43# @ECLASS-VARIABLE: PV_MAJOR
44# @DESCRIPTION:
45# The first two components of the PV variable.
46PV_MAJOR=$(get_version_component_range 1-2)
47
48# @FUNCTION: add_bdepends
49# @USAGE: <package atom>
50# @DESCRIPTION:
51# Adds to the DEPEND variable
52add_bdepend() {
53 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
54 DEPEND="${DEPEND} $@"
55}
56
57# @FUNCTION: add_rdepends
58# @USAGE: <package atom>
59# @DESCRIPTION:
60# Adds to the RDEPEND variable
61add_rdepend() {
62 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
63 RDEPEND="${RDEPEND} $@"
64}
65
66# @FUNCTION: add_depend
67# @USAGE: <package atom>
68# @DESCRIPTION:
69# Adds to the DEPEND and RDEPEND variables
70add_depend() {
71 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
72 DEPEND="${DEPEND} $@"
73 RDEPEND="${RDEPEND} $@"
74}
75
76# @ECLASS-VARIABLE: TARBALL
77# @DESCRIPTION:
78# The GtkSharp modules are currently divided into three seperate tarball
79# distributions. The TARBALL variable holds the name of the tarball
80# to which GTK_SHARP_MODULE belongs.
81case ${GTK_SHARP_MODULE} in
82 glib|glade|gtk|gdk|atk|pango|gtk-dotnet|gtk-gapi|gtk-docs)
83 TARBALL="gtk-sharp"
84 case ${PVR} in
85 2.12.*)
86 SRC_URI="mirror://gentoo/${TARBALL}-2.12.7.patch.bz2"
87 #Upstream: https://bugzilla.novell.com/show_bug.cgi?id=$bugno
88 #Upstream bug #470390 for the gtk-sharp-2.12.7.patch
89 PATCHES=(
90 "${WORKDIR}/${TARBALL}-2.12.7.patch"
91 )
92 EAUTORECONF="YES"
93 add_bdepend "=sys-devel/automake-1.10*"
94 add_bdepend ">=sys-devel/autoconf-2.61"
95 ;;
96 esac
97 ;;
98 art|gnome|gnomevfs|gconf)
99 TARBALL="gnome-sharp"
100 add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
101 has "${GTK_SHARP_MODULE}" "${gapi_users_list}" && \
102 add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
103 case ${PVR} in
104 2.24.1*)
105 SRC_URI="mirror://gentoo/${TARBALL}-2.24.1.patch.bz2"
106 PATCHES=(
107 "${WORKDIR}/${TARBALL}-2.24.1.patch"
108 )
109 EAUTORECONF="YES"
110 add_bdepend "=sys-devel/automake-1.10*"
111 add_bdepend ">=sys-devel/autoconf-2.61"
112 ;;
113 esac
114 ;;
115 gnome-desktop|gnome-print|gnome-panel|gtkhtml|gtksourceview|nautilusburn|rsvg|vte|wnck)
116 TARBALL="gnome-desktop-sharp"
117 add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
118 add_depend "=dev-dotnet/gnome-sharp-${PV_MAJOR}*"
119 add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
120 ;;
121 *)
122 eerror "Huh? Sonny boy, looks like your GTK_SHARP_MODULE is not on the approved list. BAILING!"
123 die "How did we get here!!?"
124 ;;
125esac
126
127case ${PF} in
128 #gtk-sharp tarball
129 gtk-sharp-docs*)
130 add_depend ">=virtual/monodoc-2.0"
131 ;;
132 gtk-sharp-gapi*)
133 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
134 add_depend "dev-perl/XML-LibXML"
135 ;;
136 gtk-sharp-*)
137 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
138 add_depend "~dev-dotnet/glib-sharp-${PV}"
139 add_depend "~dev-dotnet/atk-sharp-${PV}"
140 add_depend "~dev-dotnet/gdk-sharp-${PV}"
141 add_depend "~dev-dotnet/pango-sharp-${PV}"
142 ;;
143 gdk-sharp-*)
144 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
145 add_depend "~dev-dotnet/glib-sharp-${PV}"
146 add_depend "x11-libs/gtk+:2"
147 add_depend "~dev-dotnet/pango-sharp-${PV}"
148 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
149 ;;
150 atk-sharp-*)
151 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
152 add_depend "~dev-dotnet/glib-sharp-${PV}"
153 add_depend "dev-libs/atk"
154 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
155 ;;
156 glib-sharp-*)
157 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
158 add_depend "dev-libs/glib:2"
159 ;;
160 pango-sharp-*)
161 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
162 add_depend "~dev-dotnet/glib-sharp-${PV}"
163 add_depend "x11-libs/pango"
164 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
165 ;;
166 gtk-dotnet-*)
167 add_depend "~dev-dotnet/glib-sharp-${PV}"
168 add_depend "~dev-dotnet/gdk-sharp-${PV}"
169 add_depend "~dev-dotnet/pango-sharp-${PV}"
170 add_depend "~dev-dotnet/gtk-sharp-${PV}"
171 add_depend "dev-lang/mono[-minimal]"
172 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
173 ;;
174 glade-sharp-*)
175 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
176 add_depend "~dev-dotnet/glib-sharp-${PV}"
177 add_depend "~dev-dotnet/atk-sharp-${PV}"
178 add_depend "~dev-dotnet/gdk-sharp-${PV}"
179 add_depend "~dev-dotnet/gtk-sharp-${PV}"
180 add_depend "~dev-dotnet/pango-sharp-${PV}"
181 add_depend ">=gnome-base/libglade-2.3.6"
182 ;;
183 #gnome-sharp tarball
184 art-sharp-*)
185 add_depend ">=media-libs/libart_lgpl-2.3.20"
186 ;;
187 gnome-sharp-*)
188 add_depend ">=gnome-base/libgnomeui-${PV_MAJOR}"
189 add_depend ">=gnome-base/gnome-panel-${PV_MAJOR}"
190 add_depend "~dev-dotnet/gnomevfs-sharp-${PV}"
191 add_depend "~dev-dotnet/art-sharp-${PV}"
192 add_depend ">=gnome-base/libgnomecanvas-${GNOMECANVAS_REQUIRED_VERSION}"
193 ;;
194 gconf-sharp-*)
195 add_depend ">=gnome-base/gconf-${PV_MAJOR}"
196 add_depend ">=dev-dotnet/glade-sharp-${GTK_SHARP_REQUIRED_VERSION}"
197 add_depend "~dev-dotnet/gnome-sharp-${PV}"
198 add_depend "~dev-dotnet/art-sharp-${PV}"
199 ;;
200 gnomevfs-sharp-*)
201 add_depend ">=gnome-base/gnome-vfs-${PV_MAJOR}"
202 ;;
203 #gnome-desktop-sharp tarball
204 gnome-desktop-sharp-*)
205 # NOTE: This is REQUIRED to be locked to PV_MAJOR
206 # libgnome-desktop-2.so.INTEGER is hardcoded in gnomedesktop-sharp.dll.config
207 add_depend "=gnome-base/gnome-desktop-${PV_MAJOR}*"
208 ;;
209 gnome-panel-sharp-*)
210 add_depend ">=gnome-base/gnome-panel-${PV_MAJOR}"
211 ;;
212 gnome-print-sharp-*)
213 add_depend ">=gnome-base/libgnomeprint-${API_VERSION}"
214 ;;
215 gtkhtml-sharp-*)
216 #NOTE: gtkhtml dependency must follow gtkhtml-sharp version.
217 #i.e. gtkhtml-sharp-2.24.0 >=gtkhtml-3.24
218 # gtkhtml-sharp-2.16.0 >=gtkhtml-3.16
219 # See bug 249540 for unpleasant side effects.
220 add_depend ">=gnome-extra/gtkhtml-$(($(get_version_component_range 1) + 1 )).$(get_version_component_range 2)"
221 ;;
222 gtksourceview-sharp-*)
223 add_depend ">=x11-libs/gtksourceview-${GTKSOURCEVIEW_REQUIRED_VERSION}:2.0"
224 ;;
225 nautilusburn-sharp-*)
226 add_depend ">=gnome-extra/nautilus-cd-burner-${PV_MAJOR}"
227 ;;
228 rsvg-sharp-*)
229 add_depend ">=gnome-base/librsvg-${RSVG_REQUIRED_VERSION}"
230 ;;
231 vte-sharp-*)
232 add_depend ">=x11-libs/vte-${VTE_REQUIRED_VERSION}"
233 ;;
234 wnck-sharp-*)
235 add_depend ">=x11-libs/libwnck-${PV_MAJOR}"
236 ;;
237esac
238
239# @ECLASS-VARIABLE: DESCRIPTION
240# @DESCRIPTION:
241# Default value: GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball
33DESCRIPTION="GtkSharp's ${GTK_SHARP_MODULE} module" 242DESCRIPTION="GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball"
243# @ECLASS-VARIABLE: HOMEPAGE
244# @DESCRIPTION:
245# Default value: http://www.mono-project.com/GtkSharp
34HOMEPAGE="http://www.mono-project.com/GtkSharp" 246HOMEPAGE="http://www.mono-project.com/GtkSharp"
35 247# @ECLASS-VARIABLE: DESCRIPTION
248# @DESCRIPTION:
249# Default value: LGPL-2.1
36LICENSE="LGPL-2.1" 250LICENSE="LGPL-2.1"
37 251
38DEPEND="=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}* 252add_depend ">=dev-lang/mono-2.0.1"
39 >=sys-apps/sed-4 253add_bdepend ">=sys-apps/sed-4"
40 >=dev-util/pkgconfig-0.23" 254add_bdepend ">=dev-util/pkgconfig-0.23"
41RDEPEND="=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*" 255add_bdepend ">=app-shells/bash-3.1"
42 256
43RESTRICT="test" 257IUSE="debug"
258# @ECLASS-VARIABLE: S
259# @DESCRIPTION:
260# Default value: ${WORKDIR}/${TARBALL}-${PV}
261S="${WORKDIR}/${TARBALL}-${PV}"
262# @ECLASS-VARIABLE: SRC_URI
263# @DESCRIPTION:
264# Default value: mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2
265SRC_URI="${SRC_URI}
266 mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2"
44 267
45# The GtkSharp modules are currently divided into three seperate tarball 268# @FUNCTION: get_sharp_apis
46# distributions. Figure out which of these our component belongs to. This is 269# @USAGE: <type> <pkgconfig-package>
47# done to avoid passing bogus configure parameters, as well as to return the 270# @RETURN: .NET API files
48# correct tarball to download. Note that this makes ${GTK_SHARP_TARBALL_PREFIX} 271# @DESCRIPTION:
49# obsolete. 272# Given a valid pkg-config package, will return a list of API xml files.
50gnome_sharp_module_list="art gnome gnomevfs" 273# <type> can be either --prefixed or --bare. If prefixed, each API file
51gnome_desktop_sharp_module_list="gnome-print gnome-panel gtkhtml gtksourceview nautilusburn rsvg vte wnck" 274# will be prefixed with -I:
275get_sharp_apis() {
276 [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
277 get_sharp_assemblies "$@"
278}
52 279
53if [[ " ${gnome_sharp_module_list} " == *" ${GTK_SHARP_MODULE} "* ]] ; then 280# @FUNCTION: get_sharp_assemblies
54 my_module_list="${gnome_sharp_module_list}" 281# @USAGE: <type> <pkgconfig-package>
55 my_tarball="gnome-sharp" 282# @RETURN: .NET .dll assemblies
283# @DESCRIPTION:
284# Given a valid pkg-config package, will return a list of .dll assemblies.
285# <type> can be either --prefixed or --bare. If prefixed, each .dll file
286# will be prefixed with -r:
287get_sharp_assemblies() {
288 [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
289 local string config=libs prefix="-r:"
290 local -a rvalue
291 [[ "${FUNCNAME[1]}" = "get_sharp_apis" ]] && config=cflags && prefix="-I:"
292 for string in $(pkg-config --${config} ${2} 2> /dev/null)
293 do
294 rvalue+=( ${string#-?:} )
295 done
56 296
57# While gnome-desktop-sharp is a part of gnome-desktop-sharp (0_o) it is not a 297 case $1 in
58# configurable component, so we don't want to put it into the module list. 298 --bare)
59# Result is that we have to check for it manually here and in src_configure. 299 :
60elif [[ " ${gnome_desktop_sharp_module_list} " == *" ${GTK_SHARP_MODULE} "* || 300 ;;
61 "${GTK_SHARP_MODULE}" == "gnome-desktop" ]] ; then 301 --prefixed)
62 my_module_list="${gnome_desktop_sharp_module_list}" 302 for (( i=0 ; i< ${#rvalue[@]} ; i++ ))
63 my_tarball="gnome-desktop-sharp" 303 do
64else 304 rvalue[$i]=${prefix}${rvalue[$i]}
65 die "unknown GtkSharp module: ${GTK_SHARP_MODULE}" 305 done
306 ;;
307 *)
308 die "${FUNCNAME}: Unknown parameter"
309 ;;
310 esac
311 echo "${rvalue[@]}"
312}
313
314# @FUNCTION: phase_hook
315# @USAGE: <prefix>
316# Looks for functions named <prefix>_caller_suffix and executes them.
317# _caller_suffix is the calling function with the prefix
318# gtk-sharp-module removed.
319phase_hook() {
320 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs one argument"
321 if [[ "$(type -t ${1}${FUNCNAME[1]#gtk-sharp-module})" = "function" ]]
322 then
323 ebegin "Phase-hook: Running ${1}${FUNCNAME[1]#gtk-sharp-module}"
324 ${1}${FUNCNAME[1]#gtk-sharp-module}
325 eend 0
66fi 326 fi
327}
67 328
68MY_P=${my_tarball}-${PV} 329# @FUNCTION: ac_path_prog_override
69S=${WORKDIR}/${MY_P} 330# @USAGE: <PROG> [path]
331# @DESCRIPTION:
332# Override AC_PATH_PROG() autoconf macros. Path will be set to " " if
333# not specified.
334ac_path_prog_override() {
335 if [[ ${#@} -lt 1 || ${#@} -gt 2 ]]
336 then
337 eerror "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
338 eerror "AC_PATH_PROG(PARAM1, param2)"
339 die "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
340 fi
341 export ac_cv_path_${1}="${2:- }"
342}
70 343
71# Since all interesting versions are hosted on the GNOME server anyway it's the
72# only one we support, for now.
73SRC_URI="mirror://gnome/sources/${my_tarball}/${PV%.*}/${MY_P}.tar.bz2
74 mirror://gentoo/${MY_P}-configurable.diff.gz
75 http://dev.gentoo.org/~ikelos/devoverlay-distfiles/${MY_P}-configurable.diff.gz"
76 344
345# @FUNCTION: pkg_check_modules_override
346# @USAGE: <GROUP> [package1] [package2]
347# @DESCRIPTION:
348# Will export the appropriate variables to override PKG_CHECK_MODULES autoconf
349# macros, with the string " " by default. If packages are specified, they will
350# be looked up with pkg-config and the appropriate LIBS and CFLAGS substituted.
351# LIBS and CFLAGS can also be specified per-package with the following syntax:
352# @CODE
353# package=LIBS%CFLAGS
354# @CODE
355# = and % have no effect unless both are specified.
356# Here is an example:
357# @CODE
358# pkg_check_modules_override GASH "gtk+-2.0=-jule%" gobject-2.0
359# @CODE
360# The above example will do:
361# export GASH_CFLAGS+=" -jule"
362# export GASH_LIBS+=" "
363# export GASH_CFLAGS+=" $(pkg-config --cflags gobject-2.0)"
364# export GASH_LIBS+=" $(pkg-config --libs gobject-2.0)"
365#
366# NOTE: If a package is not found, the string " " will be inserted in place of
367# <GROUP>_CFLAGS and <GROUP>_LIBS
368pkg_check_modules_override() {
369 local package
370 local group="${1}"
371 local packages="${*:2}"
372 export ${group}_CFLAGS=" "
373 export ${group}_LIBS=" "
77 374
78### Public functions. 375 if [[ ${#@} -lt 1 ]]
376 then
377 eerror "${FUNCNAME[0]} requires at least one parameter: GROUP"
378 eerror "PKG_CHECK_MODULES(GROUP, package1 package2 etc)"
379 die "${FUNCNAME[0]} requires at least one parameter: GROUP"
380 fi
79 381
80gtk-sharp-module_fix_files() { 382 for package in $packages
81 # Change references like "/r:../art/art-sharp.dll" -> 383 do
82 # "/r:/usr/lib/pkgconfig/../../lib/mono/gtk-sharp-2.0/art-sharp.dll" and references like 384 if [[ ${package/=} != ${package} && ${package/\%} != ${package} ]]
83 # "../glib/glib-sharp.xml" or "$(top_srcdir)/glib/glib-sharp.xml" -> 385 then
84 # "${gapi_dir}/glib-sharp.xml". 386 package_cflag_libs=${package##*=}
85 # 387 export ${group}_CFLAGS+=" ${package_cflag_libs%%\%*}"
86 # We also make sure to call the installed gapi-fixup and gapi-codegen and 388 export ${group}_LIBS+=" ${package_cflag_libs##*\%}"
87 # not the ones that would be built locally. 389 else
88 local gapi_dir="${ROOT}/usr/share/gapi${GTK_SHARP_SLOT_DEC}" 390 if pkg-config --exists $package
391 then
392 export ${group}_CFLAGS+=" $(pkg-config --cflags $package)"
393 export ${group}_LIBS+=" $(pkg-config --libs $package)"
394 else
395 export ${group}_CFLAGS+=" "
396 export ${group}_LIBS+=" "
397 fi
398 fi
399 done
400}
89 401
90 local makefiles=( $(find "${S}" -name Makefile.in) ) 402# @FUNCTION: gtk-sharp-tarball-post_src_prepare
403# @DESCRIPTION:
404# Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
405# local assemblies to the installed ones. Is only called by src_prepare when
406# $GTK_SHARP_MODULE is a member of $gtk_sharp_module_list.
407gtk-sharp-tarball-post_src_prepare() {
408 cd "${S}/${GTK_SHARP_MODULE_DIR}"
91 sed -i \ 409 sed -i \
92 -e "s;\(\.\.\|\$(top_srcdir)\)/[[:alpha:]]*/\([[:alpha:]]*\(-[[:alpha:]]*\)*\).xml;${gapi_dir}/\2.xml;g" \ 410 -e "s; \$(srcdir)/../glib/glib-api.xml; $(get_sharp_apis --bare glib-sharp-2.0);" \
411 -e "s; ../pango/pango-api.xml; $(get_sharp_apis --bare pango-sharp-2.0);" \
412 -e "s; ../atk/atk-api.xml; $(get_sharp_apis --bare atk-sharp-2.0);" \
413 -e "s; ../gdk/gdk-api.xml; $(get_sharp_apis --bare gdk-sharp-2.0);" \
414 -e "s; ../gtk/gtk-api.xml; $(get_sharp_apis --bare gtk-sharp-2.0);" \
415 -e "s; \.\./glib/glib-sharp.dll; $(get_sharp_assemblies --bare glib-sharp-2.0);g" \
416 -e "s; \.\./pango/pango-sharp.dll; $(get_sharp_assemblies --bare pango-sharp-2.0);g" \
417 -e "s; \.\./atk/atk-sharp.dll; $(get_sharp_assemblies --bare atk-sharp-2.0);g" \
418 -e "s; \.\./gdk/gdk-sharp.dll; $(get_sharp_assemblies --bare gdk-sharp-2.0);g" \
419 -e "s; \.\./gtk/gtk-sharp.dll; $(get_sharp_assemblies --bare gtk-sharp-2.0);g" \
420 -e "s;\$(RUNTIME) \$(top_builddir)/parser/gapi-fixup.exe;/usr/bin/gapi2-fixup;" \
421 -e "s;\$(RUNTIME) \$(top_builddir)/generator/gapi_codegen.exe;/usr/bin/gapi2-codegen;" \
422 -e "s:\$(SYMBOLS) \$(top_builddir)/parser/gapi-fixup.exe:\$(SYMBOLS):" \
423 -e "s:\$(INCLUDE_API) \$(top_builddir)/generator/gapi_codegen.exe:\$(INCLUDE_API):" \
424 $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
425}
426
427# @FUNCTION: gnome-sharp-tarball-post_src_prepare
428# @DESCRIPTION:
429# Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
430# local assemblies to the installed ones. Is only called by src_prepare when
431# $GTK_SHARP_MODULE is a member of $gnome_sharp_module_list.
432gnome-sharp-tarball-post_src_prepare() {
433 cd "${S}/${GTK_SHARP_MODULE_DIR}"
434 sed -i \
435 -e "s; ../gnomevfs/gnome-vfs-api.xml; $(get_sharp_apis --bare gnome-vfs-sharp-2.0);" \
436 -e "s; ../art/art-api.xml; $(get_sharp_apis --bare art-sharp-2.0);" \
93 -e "s; \.\./art/art-sharp.dll; $(get_sharp_lib art-sharp-2.0);g" \ 437 -e "s; \.\./art/art-sharp.dll; $(get_sharp_assemblies --bare art-sharp-2.0);g" \
94 -e "s;\.\./gnomevfs/gnome-vfs-sharp.dll;$(get_sharp_lib gnome-vfs-sharp-2.0);g" \ 438 -e "s; \.\./gnomevfs/gnome-vfs-sharp.dll; $(get_sharp_assemblies --bare gnome-vfs-sharp-2.0);g" \
95 -e "s;\$(top_builddir)/art/art-sharp.dll;$(get_sharp_lib art-sharp-2.0);" \ 439 -e "s;/r:\$(top_builddir)/art/art-sharp.dll;$(get_sharp_assemblies --prefixed art-sharp-2.0);" \
96 -e "s;\$(top_builddir)/gnome/gnome-sharp.dll;$(get_sharp_lib gnome-sharp-2.0);" \ 440 -e "s;/r:\$(top_builddir)/gnome/gnome-sharp.dll;$(get_sharp_assemblies --prefixed gnome-sharp-2.0);" \
97 "${makefiles[@]}" || die "failed to fix GtkSharp makefiles" 441 $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
98} 442}
99 443
100get_sharp_lib() { 444# @FUNCTION: gtk-sharp-module_src_prepare
101 S="$(pkg-config --libs ${1})" 445# @DESCRIPTION:
102 S=${S%% *} 446# Runs autopatch from base.eclass, eautoreconf if EAUTORECONF is set to any
103 printf ${S#-r:} 447# value.
104} 448# Contains a phase_hook, runs very last.
105 449# phase_hook prefix trigger: ${TARBALL}-tarball-post
450# Is exported.
106gtk-sharp-module_src_prepare() { 451gtk-sharp-module_src_prepare() {
107 # Make selecting components configurable. 452 base_src_util autopatch
108 epatch "${WORKDIR}/${MY_P}-configurable.diff" 453# @ECLASS-VARIABLE: EAUTORECONF
454# @DESCRIPTION:
455# If set, EAUTORECONF will be run during src_prepare.
456 [[ ${EAUTORECONF} ]] && eautoreconf
457 phase_hook ${TARBALL}-tarball-post
458}
109 459
110 # Disable building samples, #16015. 460# @FUNCTION: gtk-sharp-tarball_src_configure
111 sed -i -e "s:sample::" "${S}/Makefile.am" || die 461# @DESCRIPTION:
462# Sets some environment variables that will allow us to make the dependencies
463# for each ebuild be only its own dependencies, without patching configure.
464# Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
465# is a member of $gtk_sharp_module_list.
466gtk-sharp-tarball_src_configure() {
467 pkg_check_modules_override GLIB gobject-2.0
468 pkg_check_modules_override GIO gio-2.0
469 pkg_check_modules_override PANGO pango
470 pkg_check_modules_override ATK atk
471 pkg_check_modules_override GTK gtk+-2.0
472 pkg_check_modules_override GLADE libglade-2.0
473}
112 474
113 eautoreconf 475# @FUNCTION: gnome-sharp-tarball_src_configure
476# @DESCRIPTION:
477# Sets some environment variables that will allow us to make the dependencies
478# for each ebuild be only its own dependencies. Without patching configure.
479# Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
480# is a member of $gnome_sharp_module_list.
481gnome-sharp-tarball_src_configure() {
482 pkg_check_modules_override GLADESHARP glade-sharp-2.0
483 pkg_check_modules_override GAPI gapi-2.0
484 ac_path_prog_override GAPI_PARSER /usr/bin/gapi2-parser
485 ac_path_prog_override GAPI_CODEGEN /usr/bin/gapi2-codegen
486 ac_path_prog_override GAPI_FIXUP /usr/bin/gapi2-fixup
487}
114 488
489# @FUNCTION: gtk-sharp-module_src_configure
490# @USAGE: [econf-arguments]
491# @DESCRIPTION:
492# Calls econf with some default values.
493# Contains a phase_hook, run before econf.
494# phase_hook prefix trigger: ${TARBALL}-tarball
495# Is exported.
496gtk-sharp-module_src_configure() {
497 phase_hook ${TARBALL}-tarball
498 econf --disable-static \
499 --disable-dependency-tracking \
500 --disable-maintainer-mode \
501 $(use debug &&echo "--enable-debug" ) \
502 ${@} || die "econf failed"
503}
504
505# @FUNCTION: gtk-sharp-module_src_compile
506# @DESCRIPTION:
507# Calls emake in the subdir of the module.
508# Sets CSC=/usr/bin/gmcs. Deletes top_srcdir Makefiles to prevent recursing in
509# case we missed some dll references.
510# Is exported.
511gtk-sharp-module_src_compile() {
512 rm -f "${S}"/Makefile* &> /dev/null
115 cd "${S}/${GTK_SHARP_MODULE_DIR}" 513 cd "${S}/${GTK_SHARP_MODULE_DIR}"
116 514 emake CSC=/usr/bin/gmcs || die "emake failed"
117 gtk-sharp-module_fix_files
118} 515}
119 516
120gtk-sharp-module_src_configure() { 517# @FUNCTION: gtk-sharp-module_src_install
121 # Disable any module besides one(s) we want. 518# @DESCRIPTION:
122 local module gtk_sharp_conf 519# Installs the module. Fixes up lib paths so they're multilib-safe.
123 520# Gets rid of .la files.
124 einfo "Configuring to build ${PN} module ..." 521# Is exported.
125
126 # No bogus configure parameters please.
127 [[ ${GTK_SHARP_MODULE} == "gnome-desktop" ]] && GTK_SHARP_MODULE=
128
129 for module in ${GTK_SHARP_MODULE} ${GTK_SHARP_MODULE_DEPS} ; do
130 my_module_list=${my_module_list/${module}/}
131 done
132 for module in ${my_module_list} ; do
133 gtk_sharp_conf="${gtk_sharp_conf} --disable-${module} "
134 done
135 for module in ${GTK_SHARP_MODULE} ${GTK_SHARP_MODULE_DEPS} ; do
136 gtk_sharp_conf="${gtk_sharp_conf} --enable-${module} "
137 done
138
139 cd "${S}"
140 econf ${@} ${gtk_sharp_conf} || die "econf failed"
141}
142
143gtk-sharp-module_src_compile() { 522gtk-sharp-module_src_install() {
144
145 cd "${S}/${GTK_SHARP_MODULE_DIR}" 523 cd "${S}/${GTK_SHARP_MODULE_DIR}"
146 LANG=C emake || die "emake failed"
147}
148
149gtk-sharp-module_src_install() {
150 cd "${GTK_SHARP_MODULE_DIR}"
151 LANG=C emake DESTDIR=${D} install || die "emake install failed" 524 emake DESTDIR="${D}" install || die "emake install failed"
525 mono_multilib_comply
526 find "${D}" -type f -name '*.la' -exec rm -rf '{}' '+' || die "la removal failed"
527 [[ $(find "${D}" -type f|wc -l) -lt 3 ]] && die "Too few files. This smells like a failed install."
152} 528}
153 529
154EXPORT_FUNCTIONS src_prepare src_configure src_compile src_install 530EXPORT_FUNCTIONS src_prepare src_configure src_compile src_install

Legend:
Removed from v.1.6  
changed lines
  Added in v.1.19

  ViewVC Help
Powered by ViewVC 1.1.20